﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace merge_it2
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }
        //load names of available serial ports into list
        private void button1_Click(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                comboBox1.Items.Add(port);
            }
        }
        //select serial port from list 
        private void comboBox1_SelectionChangeCommitted(object sender, EventArgs e)
        {
            serialPort1.PortName = comboBox1.SelectedItem.ToString();
        }

        string t;

        private void button2_Click(object sender, EventArgs e)
        {
            t = comboBox1.Text.ToString();
            serialPort1.PortName = comboBox1.SelectedItem.ToString();
            sErial(t);
        }

        //sErial function to open and get data from serial port
        void sErial(string Port_name)
        {
            //sp = new SerialPort(Port_name, 9600, Parity.None, 8, StopBits.One);
            serialPort1.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
            serialPort1.Open();
        }

        //DataReceivedHandler function to put text into richTextBox
        private void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
        {
            //SerialPort sp = (SerialPort)sender;
            string w = serialPort1.ReadExisting();
            if (w != String.Empty)
            //     if (w != "^")
            {
                Invoke(new Action(() => richTextBox1.AppendText(w)));
            }

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

    }
}
