﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

enum Day { Sunday, Monday, Tuesday, Wednesday, Thursday, Friday, Saturday };

namespace merge_it2
{
    public partial class Form3 : Form
    {
        schedule mainSchedule = new schedule();
        public Form3()
        {
            InitializeComponent();
        }

        //retrieve serial port names into comboBox1
        private void button1_Click(object sender, EventArgs e)
        {
            comboBox1.Items.Clear();
            foreach (string item in System.IO.Ports.SerialPort.GetPortNames())
            {
                //store the each retrieved available prot names into the Listbox...
                comboBox1.Items.Add(item);
            }
        }

        //select serial port
        private void comboBox1_SelectionChangeCommitted(object sender, EventArgs e)
        {
            serialPort1.PortName = comboBox1.SelectedItem.ToString();
        }

        //save button -- get data from differnt fields
        private void button2_Click(object sender, EventArgs e)
        {
            //string taskAddress = taskInput.Text;
            //  string hour = hourInput.Text;
            string getTask = comboBox4.SelectedItem.ToString();
            if (getTask == "Appointment")
            {
                getTask = "App";
            }
            if (getTask == "Medication")
            {
                getTask = "Med";
            }

            int getMin, getHour;
            Int32.TryParse(comboBox2.SelectedItem.ToString(), out getMin);
            Int32.TryParse(comboBox3.SelectedItem.ToString(), out getHour);
            string getAMPM = comboBox5.SelectedItem.ToString();
            int[] days = new int[7];

            //int i = 0;
            /*
            foreach (Object items in checkedListBox1.CheckedItems)
            {

                if (items.Equals("Sunday")) days[0] = 1;
                else days[0] = 0;
                if (items.Equals("Monday")) days[1] = 1;
                else days[1] = 0;
                if (items.Equals("Tuesday")) days[2] = 1;
                else days[2] = 0;
                if (items.Equals("Wednesday")) days[3] = 1;
                else days[3] = 0;
                if (items.Equals("Thursday")) days[4] = 1;
                else days[4] = 0;
                if (items.Equals("Friday")) days[5] = 1;
                else days[5] = 0;
                if (items.Equals("Saturday")) days[6] = 1;
                else days[6] = 0;
                //MessageBox.Show(items.ToString());

            }*/
            int count = 0;
            for (Day b = Day.Sunday; b != Day.Saturday; b++)
            {

                if (Enum.GetName(typeof(Day), b).ToString() == checkedListBox1.CheckedItems[count].ToString())
                {
                    days[(int)b] = 1;
                    if (count + 1 < checkedListBox1.CheckedItems.Count) count++;
                }
                else days[(int)b] = 0;
                //show 0 or 1 for each day true or false
                //MessageBox.Show(days[(int)b].ToString());
            }
            //days[0].ToString(), days[1].ToString(),days[2].ToString(),days[3].ToString(),days[4].ToString(),days[5].ToString(),days[6].ToString())
            //string package = package_task_data(getTask, getHour, getMin, getAMPM);
            reminder reminderInstance = new reminder(getTask, getHour, getMin, getAMPM, days);
            mainSchedule.addReminder(reminderInstance);
            /*
            
             * string package = mainSchedule.returnsPackage();
             * serialPort1.Open();
            serialPort1.Write(package);
            serialPort1.Write("^");
            serialPort1.Close();
            System.Windows.Forms.MessageBox.Show(package);
             */
            System.Windows.Forms.MessageBox.Show("Task Saved");
        }

        //send button
        private void button3_Click(object sender, EventArgs e)
        {
            TimeSpan t = DateTime.UtcNow - new DateTime(1970, 1, 1);
            int secondsSinceEpoch = (int)t.TotalSeconds;
            // send secondsSinceEpoch - need to add it to the string to send
            mainSchedule.sortSchedule();
            string package = mainSchedule.returnsPackage(); //had hard coded com port (233)
            System.Windows.Forms.MessageBox.Show(package);
            serialPort1.PortName = comboBox1.SelectedItem.ToString();
            serialPort1.Open();
            string time_send = "[" + secondsSinceEpoch + "]";
            serialPort1.Write(time_send);
            System.Threading.Thread.Sleep(5000);
            for (int i = 0; i < ((package.Length + 15) / 16); i++)
            {
                if (i == ((package.Length + 15) / 16) - 1) serialPort1.Write(package.ToCharArray(), i * 16, package.Length % 16);
                else
                    serialPort1.Write(package.ToCharArray(), i * 16, 16);
                System.Threading.Thread.Sleep(1000);
            }
            serialPort1.Write("^");
            serialPort1.Close();
            // System.Windows.Forms.MessageBox.Show(package);
            System.Windows.Forms.MessageBox.Show("Send Successful");
        }

       
    }
}
